﻿Imports System.Data
Imports System.Data.OleDb
Imports Microsoft.Office.Interop.Excel

Public Class Form1

    Dim cadena As New System.Data.OleDb.OleDbConnection

    Dim m_Excel As New Microsoft.Office.Interop.Excel.Application

    Dim FechaPrimera As String
    Dim FechaUltima As String

    Dim NombreDeLaDBFuente As String = "Pruebavisu.accdb"
    Dim NombreDeLaDBParaTrabajar As String = "PruebavisuTmp.accdb"

    '' Dim FraseDeConnexion As String = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & NombreDeLaDBParaTrabajar
    Dim FraseDeConnexion As String = "Provider=Microsoft.ACE.OLEDB.16.0; Data Source=" & NombreDeLaDBParaTrabajar

    Dim OKParaXLS As Boolean

    Private Sub CopiarDBParaTrabajar()
        System.IO.File.Copy(NombreDeLaDBFuente, NombreDeLaDBParaTrabajar, True)
    End Sub

    Private Sub PreparDBParaTrabajar()
        Dim MiComando As New OleDbCommand
        Dim ComandoSQL As String

        cadena.ConnectionString = FraseDeConnexion
        cadena.Open()

        Dim MiDatos As OleDbDataReader
        Dim MiTableTmp As New Collections.Generic.Dictionary(Of Integer, String)

        MiComando = cadena.CreateCommand()
        MiComando.CommandType = CommandType.Text
        MiComando.CommandText = "SELECT ID, FechaRecepcion FROM Pacientes"

        MiDatos = MiComando.ExecuteReader()
        Do While MiDatos.Read
            MiTableTmp.Add(MiDatos.Item(0), MiDatos.Item(1))
        Loop

        MiDatos.Close()

        For L As Integer = 0 To MiTableTmp.Count - 1
            ComandoSQL = "UPDATE Pacientes Set FechaRecepcion = '" & PreparFecha(MiTableTmp.Values(L), 0) & "' WHERE ID = " & MiTableTmp.Keys(L)
            MiComando.CommandText = ComandoSQL
            MiComando.ExecuteNonQuery()
        Next

        MiTableTmp.Clear()
        MiComando.Dispose()
        cadena.Close()
    End Sub

    Private Sub EliminarDBParaTrabajar()
        System.IO.File.Delete(NombreDeLaDBParaTrabajar)
    End Sub

    Private Sub Form1_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
        cadena.Dispose()     ' estos codigos son necesarios para vaciar la memoria !!! 
        Try
            m_Excel.ActiveWorkbook.Close()
        Catch
        End Try
        m_Excel = Nothing
        EliminarDBParaTrabajar()

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        CopiarDBParaTrabajar()
        PreparDBParaTrabajar()
        Try
            cadena.ConnectionString = FraseDeConnexion
            cadena.Open()

            OKParaXLS = False
            Mostrar()
            LLENAR()
            '      MsgBox("Conectado con la Base de Datos", vbCritical, "Aviso")
        Catch ex As Exception
            MsgBox("No se conceto con la Base de Datos" & " " & ex.Message, vbCritical, "Aviso")
        End Try
    End Sub

    Private Sub Mostrar()   ' Nunca ejecutar
        'Dim oda As New OleDbDataAdapter
        'Dim ods As New DataSet
        'Dim consulta As String
        'consulta = "Select *From Pacientes"
        'oda = New OleDbDataAdapter(consulta, cadena)
        'ods.Tables.Add("Pacientes")
        'oda.Fill(ods.Tables("Pacientes"))
        'oda.Dispose()
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        FechaPrimera = DateTimePicker1.Value.ToString("dd/MM/yyyy")
        FechaUltima = DateTimePicker2.Value.ToString("dd/MM/yyyy")

        Dim FraseSQL As String = "SELECT * FROM Pacientes " &
        " Where FechaRecepcion BETWEEN '" & PreparFecha(FechaPrimera, 1) & _
        "' AND '" & PreparFecha(FechaUltima, 1) & _
        "' AND NombreMedicion = '" & ComboBox1.Text & "' ORDER BY Paciente ASC, FechaRecepcion ASC, Column1 ASC"

        Dim oda As New OleDbDataAdapter(FraseSQL, cadena)
        Dim ods As New DataSet
        oda.Fill(ods)

        DataGridView1.AllowUserToAddRows = False    ' para no tener linea vacia ...

        If ods.Tables(0).Rows.Count > 0 Then
            DataGridView1.DataSource = ods.Tables(0)
            OKParaXLS = True
        Else
            If DataGridView1.Rows.Count > 0 Then
                DataGridView1.DataSource = Nothing
                DataGridView1.Rows.Clear()
            End If
            OKParaXLS = False
        End If
        oda.Dispose()
    End Sub

    Private Sub LLENAR()
        Dim Da As New OleDbDataAdapter("SELECT distinct NombreMedicion From Pacientes", cadena)
        Dim DT As New System.Data.DataTable
        Da.Fill(DT)
        DT.TableName = "NombreMedicionPaciente"
        ComboBox1.DataSource = DT
        ComboBox1.DisplayMember = "NombreMedicion"
        Da.Dispose()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        If Not OKParaXLS Then
            Exit Sub
        Else
            OKParaXLS = False
        End If

        Try
            If Not m_Excel.ActiveWorkbook Is Nothing Then
                m_Excel.ActiveWorkbook.Close()
            End If
        Catch
        End Try

        Dim ColumnaPaciente As Integer
        Dim ColumnaFecha As Integer
        Dim ColumnaValor As Integer
        Dim ColumnaNombreMedicion As Integer
        Dim PrimeraLinea As Integer
        Dim CantidadLinea As Integer = 0
        Dim ColumnaValorXLS As Integer

        Dim PacienteActual As String

        For C As Integer = 0 To DataGridView1.Columns.Count - 1
            If DataGridView1.Columns(C).HeaderText = "FechaRecepcion" Then ColumnaFecha = C
            If DataGridView1.Columns(C).HeaderText = "Paciente" Then ColumnaPaciente = C
            If DataGridView1.Columns(C).HeaderText = "VALOR" Then ColumnaValor = C
            If DataGridView1.Columns(C).HeaderText = "NombreMedicion" Then ColumnaNombreMedicion = C
        Next C

        For R As Integer = 0 To DataGridView1.Rows.Count - 1
            DataGridView1.Item(ColumnaFecha, R).Value = PreparFecha(DataGridView1.Item(ColumnaFecha, R).Value, 2)
        Next R

        m_Excel.Visible = True
        ''m_Excel.Workbooks.Open("D:\Tmp\EdgarES\Pacientes\Pacientes (VB)\Pacientes\bin\x64\Debug\Formato.xlsx")
        m_Excel.Workbooks.Open("C:\Users\LJE1SLP\Desktop\Formato.xlsx")
        m_Excel.Visible = False

        Dim LineaDGV As Integer = PrimeraLinea
        Dim FechaParaXLS As String
        Dim CantidadLienasParaUnaFecha As Integer
        Dim MaxCantidadLienasParaUnaFecha As Integer

        Dim ColXLS As Integer
        Dim LinXLS As Integer = 1
        Dim LineaFechaXLS As Integer = 1
        Dim Fecha As String = Nothing
        Dim FechaDate As String = FechaPrimera

        m_Excel.Cells.Select()
        m_Excel.Selection.ClearContents()
        m_Excel.Cells(1, 1).Select()
        m_Excel.Cells(1, 1) = "Date"
        m_Excel.Rows("1:1").Select()
        m_Excel.Selection.NumberFormat = "@"

        ColXLS = 2

        While PreparFecha(FechaDate, 1) <= PreparFecha(FechaUltima, 1)  ' escribir las fechas a la primera linea XLS
            m_Excel.Cells(1, ColXLS) = FechaDate
            ColXLS += 1
            FechaDate = CType(FechaDate, Date).AddDays(1).ToString("dd/MM/yyyy")
        End While

            While LineaDGV < DataGridView1.Rows.Count - 1

                For ColXLS = 2 To 200
                    Fecha = m_Excel.Cells(1, ColXLS).Text
                    If Fecha = DataGridView1.Item(ColumnaFecha, LineaFechaXLS).Value Then
                        ColumnaValorXLS = ColXLS
                        Exit For
                    End If
            Next

            FechaParaXLS = Fecha
            CantidadLinea = 0

            PacienteActual = DataGridView1.Item(ColumnaPaciente, LineaDGV).Value.ToString
            For R As Integer = LineaDGV To DataGridView1.Rows.Count - 1
                If DataGridView1.Item(ColumnaPaciente, R).Value.ToString = PacienteActual Then
                    CantidadLinea += 1
                End If
            Next R

            LinXLS += 2

            m_Excel.Cells(LinXLS, 1) = PacienteActual
            m_Excel.Cells(LinXLS + 1, 1) = DataGridView1.Item(ColumnaNombreMedicion, LineaDGV).Value

            CantidadLienasParaUnaFecha = 0
            MaxCantidadLienasParaUnaFecha = 0
            PrimeraLinea = LinXLS
            For R = LineaDGV To LineaDGV + CantidadLinea - 1
                m_Excel.Cells(LinXLS, ColumnaValorXLS) = DataGridView1.Item(ColumnaValor, LineaDGV).Value
                CantidadLienasParaUnaFecha += 1
                If CantidadLienasParaUnaFecha > MaxCantidadLienasParaUnaFecha Then
                    MaxCantidadLienasParaUnaFecha = CantidadLienasParaUnaFecha
                End If
                LineaDGV += 1
                LinXLS += 1
                If LineaDGV = DataGridView1.Rows.Count Then
                    m_Excel.Visible = True
                    Exit Sub
                End If
                Fecha = DataGridView1.Item(ColumnaFecha, LineaDGV).Value
                Dim FechaTmp As String = PreparFecha(Fecha, 1)
                While FechaTmp <> PreparFecha(FechaParaXLS, 1)
                    ColXLS += 1
                    FechaParaXLS = m_Excel.Cells(LineaFechaXLS, ColXLS).text
                    If FechaParaXLS = "" Then
                        Exit For
                    End If
                    LinXLS = PrimeraLinea
                    CantidadLienasParaUnaFecha = 0
                    ColumnaValorXLS = ColXLS
                End While
            Next R
            CantidadLinea = 0
            LinXLS = PrimeraLinea + MaxCantidadLienasParaUnaFecha
        End While
            m_Excel.Visible = True
    End Sub
 
    Private Function PreparFecha(Fecha As String, Moda As Byte) As String

        ' Moda 0 : MM/DD/YYYY ===> YYYY/MM/DD   Americana > Informatica
        ' Moda 1 : DD/MM/YYYY ===> YYYY/MM/DD   Europeana > Informatica
        ' Moda 2 : YYYY/MM/DD ===> DD/MM/YYYY   Informatica > Europeana 

        Dim Mese As String
        Dim Dia As String
        Dim Ano As String
        Dim Sep As Integer
        Sep = Fecha.IndexOf("/")
        Select Case Moda
            Case 0 ' MM/DD/YYYY ===> YYYY/MM/DD
                Mese = String.Format("{0:00}", CType(Fecha.Substring(0, Sep), Integer))
                Dia = String.Format("{0:00}", CType(Fecha.Substring(Sep + 1, Fecha.LastIndexOf("/") - Sep - 1), Integer))
                Ano = Fecha.Substring(Fecha.LastIndexOf("/") + 1, 4)
                Return Ano & "/" & Mese & "/" & Dia
            Case 1 ' DD/MM/YYYY ===> YYYY/MM/DD
                Dia = String.Format("{0:00}", CType(Fecha.Substring(0, Sep), Integer))
                Mese = String.Format("{0:00}", CType(Fecha.Substring(Sep + 1, Fecha.LastIndexOf("/") - Sep - 1), Integer))
                Ano = Fecha.Substring(Fecha.LastIndexOf("/") + 1, 4)
                Return Ano & "/" & Mese & "/" & Dia
            Case 2 ' YYYY/MM/DD ===> DD/MM/YYYY
                Ano = String.Format("{0:0000}", CType(Fecha.Substring(0, Sep), Integer))
                Mese = String.Format("{0:00}", CType(Fecha.Substring(Sep + 1, Fecha.LastIndexOf("/") - Sep - 1), Integer))
                Dia = String.Format("{0:00}", CType(Fecha.Substring(Fecha.LastIndexOf("/") + 1, 2), Integer))
                Return Dia & "/" & Mese & "/" & Ano
        End Select
        Return Nothing
    End Function

End Class